/*晶振频率<24MHZ)*/              
#include <intrins.h>
#include <reg52.h>
#define  uchar unsigned char /*宏定义*/
#define  uint  unsigned int



#define		DELAY5		{_nop_();_nop_();_nop_();/*_nop_();_nop_();*/}//适当增减延时来改变IIC速度
#define		DELAY2		{_nop_();/*_nop_();*/}					 	//400k	 
						 //100K DELAY5 增加_nop_();到20个
						 //100K DELAY2 增加_nop_();到10个

/* 常,变量定义区 */
 
unsigned char	iic_addr_b;                                                 /*端口位定义*/
sbit SDA=P1^0;            /*模拟I2C数据传送位*/
sbit SCL=P1^1;            /*模拟I2C时钟控制位*/

                                                 /*状态标志*/
bit ack;	         /*应答标志位*/
bit		iic_speed;   





/*******************************************************************
                     起动总线函数               
函数原型: void  Start_I2c();  
功能:       启动I2C总线,即发送I2C起始条件.
  
********************************************************************/
void Start_I2c()
{
  	SDA=1;   /*发送起始条件的数据信号*/
  	_nop_();
  	SCL=1;
	if(iic_speed)DELAY5;
  	SDA=0;   /*发送起始信号*/
	if(iic_speed)DELAY5;
  	SCL=0;   /*钳住I2C总线，准备发送或接收数据 */
	if(iic_speed)DELAY2;
}




/*******************************************************************
                      结束总线函数               
函数原型: void  Stop_I2c();  
功能:       结束I2C总线,即发送I2C结束条件.
  
********************************************************************/
void Stop_I2c()
{
  	SDA=0;  /*发送结束条件的数据信号*/
  	_nop_();   /*发送结束条件的时钟信号*/
  	SCL=1;  
	if(iic_speed)DELAY5;
  	SDA=1;  /*发送I2C总线结束信号*/
	if(iic_speed)DELAY5;
}




/*******************************************************************
                 字节数据传送函数               
函数原型: void  SendByte(uchar c);
功能:  将数据c发送出去,可以是地址,也可以是数据,发完后等待应答,并对
     此状态位进行操作.(不应答或非应答都使ack=0 假)     
     发送数据正常，ack=1; ack=0表示被控器无应答或损坏。
********************************************************************/
void  SendByte(uchar c)
{
 	uchar BitCnt;
 
 	for(BitCnt=0;BitCnt<8;BitCnt++)  /*要传送的数据长度为8位*/
    	{
     		if((c<<BitCnt)&0x80)SDA=1;   /*判断发送位*/
       		else  SDA=0;                
    // _nop_();
     		SCL=1;               /*置时钟线为高，通知被控器开始接收数据位*/
		if(iic_speed)DELAY5;     
    	 SCL=0; 
    	}
    
   	if(iic_speed)DELAY2;
    	SDA=1;               /*8位发送完后释放数据线，准备接收应答位*/
   	if(iic_speed)DELAY2;  
    	SCL=1;
	if(iic_speed)DELAY2;
    	if(SDA==1)ack=0;     
       	else ack=1;        /*判断是否接收到应答信号*/
    	SCL=0;
    if(iic_speed)DELAY2;
}






/*******************************************************************
                 字节数据传送函数               
函数原型: uchar  RcvByte();
功能:  用来接收从器件传来的数据,并判断总线错误(不发应答信号)，
     发完后请用应答函数。  
********************************************************************/	
uchar  RcvByte()
{
 	uchar retc;
  	uchar BitCnt;
  
  	retc=0; 
  	SDA=1;             /*置数据线为输入方式*/
  	for(BitCnt=8;BitCnt!=0;BitCnt--)
      {
        _nop_();           
        SCL=0;       /*置时钟线为低，准备接收数据位*/
	if(iic_speed)DELAY5;
        SCL=1;       /*置时钟线为高使数据线上数据有效*/
       if(iic_speed)DELAY2;
        retc=retc<<1;
        if(SDA==1)retc++; /*读数据位,接收的数据位放入retc中 */
        if(iic_speed)DELAY2; 
      	}
  	SCL=0;    
  	if(iic_speed)DELAY2;
  	return(retc);
}




/********************************************************************
                     应答子函数
原型:  void Ack_I2c(bit a);
 
功能:主控器进行应答信号,(可以是应答或非应答信号)
********************************************************************/
void Ack_I2c(bit a)
{
  
  	SDA=a;     /*在此发出应答或非应答信号 */
	if(iic_speed)DELAY2;    
  	SCL=1;
	if(iic_speed)DELAY5;
 	SCL=0;                /*清时钟线，钳住I2C总线以便继续接收*/
    if(iic_speed)DELAY2;  
}






/*******************************************************************
                    向无子地址器件发送字节数据函数               
函数原型: bit  ISendByte(uchar sla,ucahr c);  
功能:     从启动总线到发送地址，数据，结束总线的全过程,从器件地址sla.
           如果返回1表示操作成功，否则操作有误。
注意：    使用前必须已结束总线。
********************************************************************/
bit write_byte(uchar sla,uchar c)
{
   	Start_I2c();               /*启动总线*/
   	SendByte(sla);            /*发送器件地址*/
     	if(ack==0)return(0);
   	SendByte(c);               /*发送数据*/
     	if(ack==0)return(0);
  	Stop_I2c();                 /*结束总线*/ 
  	return(1);
}




/*******************************************************************
                    向有子地址器件发送多字节数据函数               
函数原型: bit  ISendStr(uchar sla,uchar suba,ucahr *s,uchar no);  
功能:     从启动总线到发送地址，子地址,数据，结束总线的全过程,从器件
          地址sla，子地址suba，发送内容是s指向的内容，发送no个字节。
           如果返回1表示操作成功，否则操作有误。
注意：    使用前必须已结束总线。
********************************************************************/
bit write_str_sub(uchar sla,uchar suba_h,uchar suba_l,uchar *s,uchar no)
{
    uchar i;
	suba_h=suba_h;
	Start_I2c();               /*启动总线*/
    SendByte(sla);            /*发送器件地址*/
   	    if(ack==0)return(0);
  	if(iic_addr_b!=0x03)  
   	{ 	if(iic_addr_b==0x01)
			{	SendByte(suba_h);
				if(ack==0)return(0);	
			}
		SendByte(suba_l);            /*发送器件子地址*/
  	   	 	if(ack==0)return(0);
   	}
    for(i=0;i<no;i++)
  	    {	   
            SendByte(*s);               /*发送数据*/
       		if(ack==0)return(0);
    		s++;
    	} 
 	Stop_I2c();                 /*结束总线*/ 
  	return(1);
}






/*******************************************************************
                    向无子地址器件读字节数据函数               
函数原型: bit  IRcvByte(uchar sla,ucahr *c);  
功能:     从启动总线到发送地址，读数据，结束总线的全过程,从器件地
          址sla，返回值在c.
           如果返回1表示操作成功，否则操作有误。
注意：    使用前必须已结束总线。
********************************************************************/
bit read_byte(uchar sla,uchar *c)
{
   	Start_I2c();                /*启动总线*/
   	SendByte(sla+1);           /*发送器件地址*/
     	if(ack==0)return(0);
   	*c=RcvByte();               /*读取数据*/
     	Ack_I2c(1);               /*发送非就答位*/
  	Stop_I2c();                  /*结束总线*/ 
  	return(1);
}



/*******************************************************************
                    向有子地址器件读取多字节数据函数               
函数原型: bit  ISendStr(uchar sla,uchar suba,ucahr *s,uchar no);  
功能:     从启动总线到发送地址，子地址,读数据，结束总线的全过程,从器件
          地址sla，子地址suba，读出的内容放入s指向的存储区，读no个字节。
           如果返回1表示操作成功，否则操作有误。
注意：    使用前必须已结束总线。
********************************************************************/
bit read_str_sub(uchar sla,uchar suba_h,uchar suba_l,uchar *s,uchar no)
{
   	uchar i;

   	Start_I2c();               /*启动总线*/
   	SendByte(sla);            /*发送器件地址*/
     	if(ack==0)return(0);
   
  	if(iic_addr_b!=0x03) 	
   		{	if(iic_addr_b==0x01)
			{	SendByte(suba_h);
				if(ack==0)return(0);	
			}
		SendByte(suba_l);            /*发送器件子地址*/
     		if(ack==0)return(0);
   		}
   	Start_I2c();
   	SendByte(sla+1);			//读，器件地址加 1
      	if(ack==0)return(0);

   	for(i=0;i<no-1;i++)
    	{   
     		*s=RcvByte();               /*发送数据*/
      		Ack_I2c(0);                /*发送就答位*/  
     		s++;
    	} 
   	*s=RcvByte();
    	Ack_I2c(1);                 /*发送非应位*/
 	Stop_I2c();                    /*结束总线*/ 
  	return(1);
}






                        /*    完毕      */
